------------------------
---      Module      ---
------------------------

local name = "FlameTurnIn"
FlameTurnIn = LibStub("AceAddon-3.0"):NewAddon(	name,
											"AceConsole-3.0",
											"AceEvent-3.0");

----------------------------
--      Localization      --
----------------------------

local L = LibStub("AceLocale-3.0"):GetLocale(name, true)

----------------------
---      Init      ---
----------------------

function FlameTurnIn:OnInitialize()
  self:RegisterEvent("GOSSIP_SHOW")
  self:RegisterEvent("QUEST_PROGRESS")
  self:RegisterEvent("QUEST_COMPLETE")
  
  self:Safe_Print(L["Loaded"])
end

--------------------------------
---      Event Handlers      ---
--------------------------------

function FlameTurnIn:GOSSIP_SHOW()
  local arg = { GetGossipAvailableQuests() }
  for i=1, #arg, 3 do
    self:Safe_Print(L["Found"]:format(arg[i]))
    if arg[i] == L["Honor the Flame"] or arg[i] == L["Desecrate this Fire!"] then
      self:Safe_Print(L["Select"]:format(arg[i], ceil(i/3)))
      SelectGossipAvailableQuest(ceil(i/3))
    end
  end
end

function FlameTurnIn:QUEST_PROGRESS()
  local title = GetTitleText()
  if title == L["Honor the Flame"] or title == L["Desecrate this Fire!"] then
    self:Safe_Print(L["Accept"]:format(title))
    AcceptQuest()
  end
end

function FlameTurnIn:QUEST_COMPLETE()
  local title = GetTitleText()
  if title == L["Honor the Flame"] or title == L["Desecrate this Fire!"] or title == L["Candy Bucket"] then
    self:Safe_Print(L["Finish"]:format(title))
    GetQuestReward(1)
  end
end

function FlameTurnIn:Safe_Print(str)
	--self:Print(str)
end
